diff --git a/helpers/packagekit.py b/helpers/packagekit.py
index 619f691..9fba15e 100644
--- a/helpers/packagekit.py
+++ b/helpers/packagekit.py
@@ -40,10 +40,10 @@ RESTART_SESSION = "session"
 # Classes
 
 class PackageKitBaseBackend:
-    
+
     def __init__(self,cmds):
         self.cmds = cmds
-        
+
     def percentage(self,percent=None):
         ''' 
         Write progress percentage
@@ -68,7 +68,7 @@ class PackageKitBaseBackend:
         @param description: Error description
         '''
         print >> sys.stderr,"error\t%s\t%s" % (err,description)
-        
+
     def package(self,id,status,summary):
         '''
         send 'package' signal
@@ -77,21 +77,21 @@ class PackageKitBaseBackend:
         @param summary: The package Summary 
         '''
         print >> sys.stdout,"package\t%s\t%s\t%s" % (status,id,summary)
-        
+
     def status(self,state):
         '''
         send 'status' signal
         @param state: STATE_DOWNLOAD, STATE_INSTALL, STATE_UPDATE, STATE_REMOVE 
         '''
         print >> sys.stderr,"status\t%s" % (state)
-        
+
     def data(self,data):
         '''
         send 'data' signal:
         @param data:  The current worked on package
         '''
         print >> sys.stderr,"data\t%s" % (data)
-        
+
     def description(self,id,group,desc,url):
         '''
         Send 'description' signal
@@ -101,7 +101,7 @@ class PackageKitBaseBackend:
         @param url: The upstream project homepage
         '''
         print >> sys.stdout,"description\t%s\t%s\t%s\t%s" % (id,group,desc,url)
-        
+
     def require_restart(self,restart_type,details):
         '''
         Send 'requirerestart' signal
@@ -109,14 +109,14 @@ class PackageKitBaseBackend:
         @param details: Optional details about the restart
         '''
         print >> sys.stderr,"requirerestart\t%s\t%s" % (restart_type,details)
-    
+
     def get_package_id(self,name,version,arch,data):
         return "%s;%s;%s;%s" % (name,version,arch,data)
 
 #
 # Backend Action Methods
-#    
-    
+#
+
     def search_name(self,opt,key):
         '''
         Implement the {backend}-search-name functionality
@@ -130,7 +130,7 @@ class PackageKitBaseBackend:
         Needed to be implemented in a sub class
         '''
         self.error(ERROR_NOT_SUPPORTED,"This function is not implemented in this backend")
-        
+
     def get_deps(self,package):
         '''
         Implement the {backend}-get-deps functionality
@@ -144,15 +144,15 @@ class PackageKitBaseBackend:
         Needed to be implemented in a sub class
         '''
         self.error(ERROR_NOT_SUPPORTED,"This function is not implemented in this backend")
-        
-        
+
+
     def refresh_cache(self):
         '''
         Implement the {backend}-refresh_cache functionality
         Needed to be implemented in a sub class
         '''
         self.error(ERROR_NOT_SUPPORTED,"This function is not implemented in this backend")
-        
+
     def install(self, package):
         '''
         Implement the {backend}-install functionality
@@ -173,5 +173,3 @@ class PackageKitBaseBackend:
         Needed to be implemented in a sub class
         '''
         self.error(ERROR_NOT_SUPPORTED,"This function is not implemented in this backend")
-        
-        
diff --git a/helpers/yum-description.py b/helpers/yum-description.py
index 2797ad5..9d53e79 100755
--- a/helpers/yum-description.py
+++ b/helpers/yum-description.py
@@ -36,13 +36,13 @@ for (pkg,values) in res:
     # do we print to stdout?
     do_print = 0;
     if options == 'installed' and installed == 'yes':
-    	do_print = 1
+        do_print = 1
     elif options == 'available' and installed == 'no':
-    	do_print = 1
+        do_print = 1
     elif options == 'all':
-    	do_print = 1
+        do_print = 1
 
     # print in correct format
     if do_print == 1:
-    	print "%s\t%s\t%s" % (installed, pkg.name, pkg.summary)
+        print "%s\t%s\t%s" % (installed, pkg.name, pkg.summary)
 
diff --git a/helpers/yumBackend.py b/helpers/yumBackend.py
index 06370f9..7fc1dbd 100644
--- a/helpers/yumBackend.py
+++ b/helpers/yumBackend.py
@@ -28,11 +28,11 @@ from urlgrabber.progress import BaseMeter,format_time,format_number
 
 
 class PackageKitYumBackend(PackageKitBaseBackend):
-    
+
     def __init__(self,args):
         PackageKitBaseBackend.__init__(self,args)
         self.yumbase = yum.YumBase()
-        
+
     def _do_search(self,searchlist,opt,key):       
         '''
         Search for yum packages
@@ -42,7 +42,7 @@ class PackageKitYumBackend(PackageKitBaseBackend):
         '''
         self.yumbase.conf.cache = 1 # Only look in cache.
         res = self.yumbase.searchGenerator(searchlist, [key])
-        
+
         count = 1
         for (pkg,values) in res:
             print pkg
@@ -50,11 +50,11 @@ class PackageKitYumBackend(PackageKitBaseBackend):
                 break
             count+=1 
             installed = '0'
-        
+
             # are we installed?
             if self.yumbase.rpmdb.installed(pkg.name):
                 installed = '1'
-        
+
             # do we print to stdout?
             do_print = 0;
             if opt == 'installed' and installed == '1':
@@ -63,19 +63,19 @@ class PackageKitYumBackend(PackageKitBaseBackend):
                 do_print = 1
             elif opt == 'all':
                 do_print = 1
-        
+
             # print in correct format
             if do_print == 1:
                 id = self.get_package_id(pkg.name, pkg.version, pkg.arch, pkg.repo)
                 self.package(id,installed, pkg.summary)
-        
+
     def search_name(self,opt,key):
         '''
         Implement the {backend}-search-nam functionality
         '''
         searchlist = ['name']
         self._do_search(searchlist, opt, key)
-            
+
     def search_details(self,opt,key):
         '''
         Implement the {backend}-search-details functionality
@@ -83,7 +83,6 @@ class PackageKitYumBackend(PackageKitBaseBackend):
         searchlist = ['name', 'summary', 'description', 'group']
         self._do_search(searchlist, opt, key)
 
-       
     def get_deps(self,package):
         '''
         Print a list of dependencies for a given package
@@ -109,8 +108,7 @@ class PackageKitYumBackend(PackageKitBaseBackend):
         Needed to be implemented in a sub class
         '''
         self.error(ERROR_NOT_SUPPORTED,"This function is not implemented in this backend")
-        
-        
+
     def refresh_cache(self):
         '''
         Implement the {backend}-refresh_cache functionality
@@ -125,10 +123,10 @@ class PackageKitYumBackend(PackageKitBaseBackend):
             if len(self.yumbase.repos.listEnabled()) == 0:
                 self.percentage(100)
                 return
-        
+
             #work out the slice for each one
             bump = (100/len(self.yumbase.repos.listEnabled()))/2
-        
+
             for repo in self.yumbase.repos.listEnabled():
                 repo.metadata_expire = 0
                 self.yumbase.repos.populateSack(which=[repo.id], mdtype='metadata', cacheonly=1)
@@ -137,13 +135,13 @@ class PackageKitYumBackend(PackageKitBaseBackend):
                 self.yumbase.repos.populateSack(which=[repo.id], mdtype='filelists', cacheonly=1)
                 pct+=bump
                 self.percentage(pct)
-        
+
             #we might have a rounding error
             self.percentage(100)
-        
+
         except yum.Errors.YumBaseError, e:
             self.error(ERROR_INTERNAL_ERROR,str(e))
-        
+
     def install(self, package):
         '''
         Implement the {backend}-install functionality
@@ -177,38 +175,38 @@ class DownloadCallback( BaseMeter ):
         BaseMeter.__init__( self )
         self.totSize = ""
         self.base = base
-               
+
     def update( self, amount_read, now=None ):
-        BaseMeter.update( self, amount_read, now )           
+        BaseMeter.update( self, amount_read, now )
 
     def _do_start( self, now=None ):
-        name = self._getName()        
-        self.updateProgress(name,0.0,"","")        
+        name = self._getName()
+        self.updateProgress(name,0.0,"","")
         if not self.size is None:
             self.totSize = format_number( self.size )
 
     def _do_update( self, amount_read, now=None ):
         fread = format_number( amount_read )
-        name = self._getName()        
+        name = self._getName()
         if self.size is None:
             # Elabsed time
             etime = self.re.elapsed_time()
             fetime = format_time( etime )
             frac = 0.0
-            self.updateProgress(name,frac,fread,fetime)      
+            self.updateProgress(name,frac,fread,fetime)
         else:
             # Remaining time
             rtime = self.re.remaining_time()
             frtime = format_time( rtime )
             frac = self.re.fraction_read()
-            self.updateProgress(name,frac,fread,frtime)      
-              
+            self.updateProgress(name,frac,fread,frtime)
+
 
     def _do_end( self, amount_read, now=None ):
         total_time = format_time( self.re.elapsed_time() )
         total_size = format_number( amount_read )
-        name = self._getName()        
-        self.updateProgress(name,1.0,total_size,total_time)      
+        name = self._getName()
+        self.updateProgress(name,1.0,total_size,total_time)
 
     def _getName(self):
         '''
@@ -219,7 +217,7 @@ class DownloadCallback( BaseMeter ):
         else:
             name = self.basename
         return name
-        
+
     def updateProgress(self,name,frac,fread,ftime):
         '''
          Update the progressbar (Overload in child class)
@@ -229,6 +227,6 @@ class DownloadCallback( BaseMeter ):
         @param ftime : formated string containing remaining or elapsed time
         '''
         self.base.sub_percentage(int( frac*100 ))
-    
-    
-        
+
+
+